# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "Stylized Explosion Generator",
    "author" : "CGBlender", 
    "description" : "Stylized Explosion Generator",
    "blender" : (3, 5, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_sna_stylized_explosion_generator_8A609(self, context):
    sna_updated_prop = self.sna_stylized_explosion_generator
    before_data = list(bpy.data.objects)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Procedural Stylized Explosion1.blend') + r'\Object', filename=sna_updated_prop, link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
    appended_B941D = None if not new_data else new_data[0]
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]


def sna_stylized_explosion_generator_enum_items(self, context):
    enum_items = [['p1', 'p1', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp1.png'))], ['p2', 'p2', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp2.png'))], ['p3', 'p3', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp3.png'))], ['p4', 'p4', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp4.png'))], ['p5', 'p5', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp5.png'))], ['p6', 'p6', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp6.png'))], ['p7', 'p7', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp7.png'))], ['p8', 'p8', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp8.png'))], ['p9', 'p9', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp9.png'))], ['p10', 'p10', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp10.png'))], ['p11', 'p11', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp11.png'))], ['p12', 'p12', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp12.png'))], ['p13', 'p13', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp13.png'))], ['p14', 'p14', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'exp14.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


class SNA_PT_STYLIZED_EXPLOSION_GENERATOR_0834C(bpy.types.Panel):
    bl_label = 'Stylized Explosion Generator'
    bl_idname = 'SNA_PT_STYLIZED_EXPLOSION_GENERATOR_0834C'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'SE'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_stylized_explosion_generator', show_labels=False, scale=5.0, scale_popup=5.0)
        col_CF3F4 = layout.column(heading='', align=False)
        col_CF3F4.alert = False
        col_CF3F4.enabled = True
        col_CF3F4.active = True
        col_CF3F4.use_property_split = False
        col_CF3F4.use_property_decorate = False
        col_CF3F4.scale_x = 1.0
        col_CF3F4.scale_y = 1.0
        col_CF3F4.alignment = 'Expand'.upper()
        col_CF3F4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Resample Curve'].inputs[2], 'default_value', text='Explosion Count', icon_value=238, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Object Info'].inputs[0], 'default_value', text='E Curve', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Set Material'].inputs[2], 'default_value', text='Explosion Material', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Math'].inputs[1], 'default_value', text='Explosion Scale', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.004'].inputs[3], 'default_value', text='Explosion Shape', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.018'].inputs[3], 'default_value', text='Explosion Shape S2', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.004'].inputs[4], 'default_value', text='Explosion Mid Scale', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.019'].inputs[1], 'default_value', text='Explosion Seed', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group'].inputs[2], 'default_value', text='Explosion Time Duration', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group'].inputs[3], 'default_value', text='E Time Step interval', icon_value=0, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Set Material.001'].inputs[2], 'default_value', text='Trail Material', icon_value=195, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Set Material.002'].inputs[2], 'default_value', text='Trail Head Material', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.011'].inputs[3], 'default_value', text='Trail Radius', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.010'].inputs[3], 'default_value', text='Trail Shape', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.007'].inputs[3], 'default_value', text='Trail Distance', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.008'].inputs[2], 'default_value', text='Trail Shape Var', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.inputs[3], 'default_value', text='Trail Shape Var 2', icon_value=198, emboss=True)
        col_CF3F4.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Group.009'].inputs[0], 'default_value', text='Trail Count', icon_value=198, emboss=True)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_stylized_explosion_generator = bpy.props.EnumProperty(name='Stylized Explosion Generator', description='', items=sna_stylized_explosion_generator_enum_items, update=sna_update_sna_stylized_explosion_generator_8A609)
    bpy.utils.register_class(SNA_PT_STYLIZED_EXPLOSION_GENERATOR_0834C)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_stylized_explosion_generator
    bpy.utils.unregister_class(SNA_PT_STYLIZED_EXPLOSION_GENERATOR_0834C)
